#!/bin/sh
logdir=/ysdisk/cache/firmware
imagedir=/ysdisk/imageupdate
firmwareimage=/ysdisk/imageupdate/uImage
invaildflag=/ysdisk/imageupdate/invaildimage
detectflag=/ysdisk/imageupdate/detectimage
nofoundflag=/ysdisk/imageupdate/nofoundimage
tmpfilename=uImage.tmp
cloudtmpfilename=cloudfirmware.tmp
worklefile=/tmp/workled.conf
wgettimeout=15
echo "$4" |grep -q -E '^[^&;<>|&$]*$'
result=$?
if [ "$result" -ne 0 ]; then
        echo "error param"
        exit 1
fi
result=0
if [ "$2" == "tftp" ];then
        echo "$5" |grep -q -E '^[a-zA-Z_0-9:\.-]*$'
        result=$?
        if [ "$result" -ne 0 ]; then
                echo "error param"  
                exit 1            
        fi            
fi
mode=$2
reset=$3
tftpserver=$4
tftpfile=$5
httpurl=$4
uploadfilepath=$4
if [ ! -d $imagedir ];then
	mkdir -p $imagedir
fi
if [ ! -d $logdir ];then
	mkdir -p $logdir
fi

if [ "$1" == "boot" ];then
	if [ -f $detectflag ];then
		rm $detectflag
	fi
	if [ -f $logdir/$tmpfilename ];then
		rm $logdir/$tmpfilename
	fi
	if [ -f $logdir/$cloudtmpfilename ];then
		rm $logdir/$cloudtmpfilename
	fi
elif [ "$1" == "start" ];then
	if [ -f $detectflag ];then
		rm $detectflag
	fi
	if [ -f $logdir/$tmpfilename ];then
		rm $logdir/$tmpfilename
	fi
	if [ -f $logdir/$cloudtmpfilename ];then
		rm $logdir/$cloudtmpfilename
	fi

	if [ -f $invaildflag ];then
		rm $invaildflag
	fi
	if [ -f $nofoundflag ];then
		rm $nofoundflag
	fi
	if [ -f $firmwareimage ];then
		rm $firmwareimage
	fi
	
	echo 100 > $worklefile 
	cd $logdir
	if [ "$mode" == "tftp" ];then
		killall -9 tftp
		/bin/tftp -b 1024 -g -r $tftpfile -l $tmpfilename $tftpserver
		srcfile=$tmpfilename
	elif [ "$mode" == "http" ];then
		/bin/wget -O $tmpfilename $httpurl -t 2 -T $wgettimeout --no-check-certificate
		srcfile=$tmpfilename
	elif [ "$mode" == "upload" ];then
		srcfile=$uploadfilepath
	elif [ "$mode" == "auto" ];then
		/ysbin/cloudfirmware upgrade
		srcfile=$tmpfilename
	fi
#detect firm correct
	touch $detectflag
	if [ ! -e $srcfile ] || [ ! -s $srcfile ];then
		imagestatu=-1
		touch $nofoundflag
		logger -t ${0##*/} "firmwareupgrade: no found image"
	else
		/bin/firmware_detect $srcfile
		imagestatu=$?
	fi
	if [ "$imagestatu" == "0" ];then
		#firmware is vaild
		if [ "$reset" == "yes" ];then
			touch /ysdisk/etc/.reset
		fi
		mv $srcfile ${firmwareimage}.bin
		date > ${firmwareimage}
		/ysbin/heartbeat reboot
		sleep 3
		if [ -f $firmwareimage ];then
			cp /etc/version $imagedir/oldversion
			/ysbin/sleeprun.sh /sbin/reboot 3
		fi
	else
		logger -t ${0##*/} "firmwareupgrade: this is invaild image"
		#firmware is invaild,delete it
		touch $invaildflag 
		rm $srcfile
	fi
	rm $detectflag
	echo 1000 > $worklefile 
elif [ "$1" == "stop" ];then
	echo 1000 > $worklefile 
	rm $tmpfilename
	rm $firmwareimage
	killall -9 firmwareupgrade.sh
fi
